Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4671)
@@ -4608,6 +4646,6 @@
 !--             surface element on RRTMG-shaped array.
 !--             Please note, as RRTMG is a single column model, surface attributes
-!--             are only obtained from horizontally aligned surfaces (for
-!--             simplicity). Taking surface attributes from horizontal and
+!--             are only obtained from upward facing horizontally aligned surfaces
+!--             (for simplicity). Taking surface attributes from horizontal and
 !--             vertical walls would lead to multiple solutions.
 !--             Moreover, for natural- and urban-type surfaces, several surface
@@ -4615,21 +4653,21 @@
 !--             To obtain bulk parameters, apply a weighted average for these
 !--             surfaces.
-                DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                   rrtm_emis = surf_lsm_h%frac(m,ind_veg_wall)  *              &
-                               surf_lsm_h%emissivity(m,ind_veg_wall)  +        &
-                               surf_lsm_h%frac(m,ind_pav_green) *              &
-                               surf_lsm_h%emissivity(m,ind_pav_green) +        &
-                               surf_lsm_h%frac(m,ind_wat_win)   *              &
-                               surf_lsm_h%emissivity(m,ind_wat_win)
-                   rrtm_tsfc = surf_lsm_h%pt_surface(m) * exner(nzb)
+                DO  m = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                   rrtm_emis = surf_lsm_h(0)%frac(m,ind_veg_wall)  *              &
+                               surf_lsm_h(0)%emissivity(m,ind_veg_wall)  +        &
+                               surf_lsm_h(0)%frac(m,ind_pav_green) *              &
+                               surf_lsm_h(0)%emissivity(m,ind_pav_green) +        &
+                               surf_lsm_h(0)%frac(m,ind_wat_win)   *              &
+                               surf_lsm_h(0)%emissivity(m,ind_wat_win)
+                   rrtm_tsfc = surf_lsm_h(0)%pt_surface(m) * exner(nzb)
                 ENDDO
-                DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                   rrtm_emis = surf_usm_h%frac(m,ind_veg_wall)  *              &
-                               surf_usm_h%emissivity(m,ind_veg_wall)  +        &
-                               surf_usm_h%frac(m,ind_pav_green) *              &
-                               surf_usm_h%emissivity(m,ind_pav_green) +        &
-                               surf_usm_h%frac(m,ind_wat_win)   *              &
-                               surf_usm_h%emissivity(m,ind_wat_win)
-                   rrtm_tsfc = surf_usm_h%pt_surface(m) * exner(nzb)
+                DO  m = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
+                   rrtm_emis = surf_usm_h(0)%frac(m,ind_veg_wall)  *              &
+                               surf_usm_h(0)%emissivity(m,ind_veg_wall)  +        &
+                               surf_usm_h(0)%frac(m,ind_pav_green) *              &
+                               surf_usm_h(0)%emissivity(m,ind_pav_green) +        &
+                               surf_usm_h(0)%frac(m,ind_wat_win)   *              &
+                               surf_usm_h(0)%emissivity(m,ind_wat_win)
+                   rrtm_tsfc = surf_usm_h(0)%pt_surface(m) * exner(nzb)
                 ENDDO
 !
@@ -4713,15 +4751,17 @@
 !--                onto respective surface elements
 !--                Horizontal surfaces
-                   DO  m = surf_lsm_h%start_index(j,i),                        &
-                           surf_lsm_h%end_index(j,i)
-                      surf_lsm_h%rad_lw_in(m)           = rrtm_lwdflx(0,k_topo)
-                      surf_lsm_h%rad_lw_out(m)          = rrtm_lwuflx(0,k_topo)
-                      surf_lsm_h%rad_lw_out_change_0(m) = rrtm_lwuflx_dt(0,k_topo)
-                   ENDDO
-                   DO  m = surf_usm_h%start_index(j,i),                        &
-                           surf_usm_h%end_index(j,i)
-                      surf_usm_h%rad_lw_in(m)           = rrtm_lwdflx(0,k_topo)
-                      surf_usm_h%rad_lw_out(m)          = rrtm_lwuflx(0,k_topo)
-                      surf_usm_h%rad_lw_out_change_0(m) = rrtm_lwuflx_dt(0,k_topo)
+                   DO l = 0, 1
+                      DO  m = surf_lsm_h(l)%start_index(j,i),                        &
+                              surf_lsm_h(l)%end_index(j,i)
+                         surf_lsm_h(l)%rad_lw_in(m)           = rrtm_lwdflx(0,k_topo)
+                         surf_lsm_h(l)%rad_lw_out(m)          = rrtm_lwuflx(0,k_topo)
+                         surf_lsm_h(l)%rad_lw_out_change_0(m) = rrtm_lwuflx_dt(0,k_topo)
+                      ENDDO
+                      DO  m = surf_usm_h(l)%start_index(j,i),                        &
+                              surf_usm_h(l)%end_index(j,i)
+                         surf_usm_h(l)%rad_lw_in(m)           = rrtm_lwdflx(0,k_topo)
+                         surf_usm_h(l)%rad_lw_out(m)          = rrtm_lwuflx(0,k_topo)
+                         surf_usm_h(l)%rad_lw_out_change_0(m) = rrtm_lwuflx_dt(0,k_topo)
+                      ENDDO
                    ENDDO
 !
@@ -4751,29 +4791,28 @@
 !--                Get albedo for direct/diffusive long/shortwave radiation at
 !--                current (y,x)-location from surface variables.
-!--                Only obtain it from horizontal surfaces, as RRTMG is a single
-!--                column model
-!--                (Please note, only one loop will entered, controlled by
-!--                start-end index.)
-                   DO  m = surf_lsm_h%start_index(j,i),                        &
-                           surf_lsm_h%end_index(j,i)
-                      rrtm_asdir(1)  = SUM( surf_lsm_h%frac(m,:) *             &
-                                            surf_lsm_h%rrtm_asdir(m,:) )
-                      rrtm_asdif(1)  = SUM( surf_lsm_h%frac(m,:) *             &
-                                            surf_lsm_h%rrtm_asdif(m,:) )
-                      rrtm_aldir(1)  = SUM( surf_lsm_h%frac(m,:) *             &
-                                            surf_lsm_h%rrtm_aldir(m,:) )
-                      rrtm_aldif(1)  = SUM( surf_lsm_h%frac(m,:) *             &
-                                            surf_lsm_h%rrtm_aldif(m,:) )
+!--                Only obtain it from upward facing horizontal surfaces,
+!--                as RRTMG is a single column model. (Please note, only
+!--                one loop will entered, controlled by start-end index.)
+                   DO  m = surf_lsm_h(0)%start_index(j,i),                        &
+                           surf_lsm_h(0)%end_index(j,i)
+                      rrtm_asdir(1)  = SUM( surf_lsm_h(0)%frac(m,:) *             &
+                                            surf_lsm_h(0)%rrtm_asdir(m,:) )
+                      rrtm_asdif(1)  = SUM( surf_lsm_h(0)%frac(m,:) *             &
+                                            surf_lsm_h(0)%rrtm_asdif(m,:) )
+                      rrtm_aldir(1)  = SUM( surf_lsm_h(0)%frac(m,:) *             &
+                                            surf_lsm_h(0)%rrtm_aldir(m,:) )
+                      rrtm_aldif(1)  = SUM( surf_lsm_h(0)%frac(m,:) *             &
+                                            surf_lsm_h(0)%rrtm_aldif(m,:) )
                    ENDDO
-                   DO  m = surf_usm_h%start_index(j,i),                        &
-                           surf_usm_h%end_index(j,i)
-                      rrtm_asdir(1)  = SUM( surf_usm_h%frac(m,:) *             &
-                                            surf_usm_h%rrtm_asdir(m,:) )
-                      rrtm_asdif(1)  = SUM( surf_usm_h%frac(m,:) *             &
-                                            surf_usm_h%rrtm_asdif(m,:) )
-                      rrtm_aldir(1)  = SUM( surf_usm_h%frac(m,:) *             &
-                                            surf_usm_h%rrtm_aldir(m,:) )
-                      rrtm_aldif(1)  = SUM( surf_usm_h%frac(m,:) *             &
-                                            surf_usm_h%rrtm_aldif(m,:) )
+                   DO  m = surf_usm_h(0)%start_index(j,i),                        &
+                           surf_usm_h(0)%end_index(j,i)
+                      rrtm_asdir(1)  = SUM( surf_usm_h(0)%frac(m,:) *             &
+                                            surf_usm_h(0)%rrtm_asdir(m,:) )
+                      rrtm_asdif(1)  = SUM( surf_usm_h(0)%frac(m,:) *             &
+                                            surf_usm_h(0)%rrtm_asdif(m,:) )
+                      rrtm_aldir(1)  = SUM( surf_usm_h(0)%frac(m,:) *             &
+                                            surf_usm_h(0)%rrtm_aldir(m,:) )
+                      rrtm_aldif(1)  = SUM( surf_usm_h(0)%frac(m,:) *             &
+                                            surf_usm_h(0)%rrtm_aldif(m,:) )
                    ENDDO
 !
@@ -4876,13 +4915,15 @@
 !--                Save surface radiative fluxes onto respective surface elements
 !--                Horizontal surfaces
-                   DO  m = surf_lsm_h%start_index(j,i),                        &
-                           surf_lsm_h%end_index(j,i)
-                      surf_lsm_h%rad_sw_in(m)     = rrtm_swdflx(0,k_topo)
-                      surf_lsm_h%rad_sw_out(m)    = rrtm_swuflx(0,k_topo)
-                   ENDDO
-                   DO  m = surf_usm_h%start_index(j,i),                        &
-                           surf_usm_h%end_index(j,i)
-                      surf_usm_h%rad_sw_in(m)     = rrtm_swdflx(0,k_topo)
-                      surf_usm_h%rad_sw_out(m)    = rrtm_swuflx(0,k_topo)
+                   DO l = 0, 1
+                      DO  m = surf_lsm_h(l)%start_index(j,i),                        &
+                              surf_lsm_h(l)%end_index(j,i)
+                         surf_lsm_h(l)%rad_sw_in(m)     = rrtm_swdflx(0,k_topo)
+                         surf_lsm_h(l)%rad_sw_out(m)    = rrtm_swuflx(0,k_topo)
+                      ENDDO
+                      DO  m = surf_usm_h(l)%start_index(j,i),                        &
+                              surf_usm_h(l)%end_index(j,i)
+                         surf_usm_h(l)%rad_sw_in(m)     = rrtm_swdflx(0,k_topo)
+                         surf_usm_h(l)%rad_sw_out(m)    = rrtm_swuflx(0,k_topo)
+                      ENDDO
                    ENDDO
 !
@@ -4908,17 +4949,19 @@
                    rad_sw_in  = 0.0_wp
                    rad_sw_out = 0.0_wp
-!--             !!!!!!!! ATTENSION !!!!!!!!!!!!!!!
+!--             !!!!!!!! ATTENTION !!!!!!!!!!!!!!!
 !--             Surface radiative fluxes should be also set to zero here
 !--                Save surface radiative fluxes onto respective surface elements
 !--                Horizontal surfaces
-                   DO  m = surf_lsm_h%start_index(j,i),                        &
-                           surf_lsm_h%end_index(j,i)
-                      surf_lsm_h%rad_sw_in(m)     = 0.0_wp
-                      surf_lsm_h%rad_sw_out(m)    = 0.0_wp
-                   ENDDO
-                   DO  m = surf_usm_h%start_index(j,i),                        &
-                           surf_usm_h%end_index(j,i)
-                      surf_usm_h%rad_sw_in(m)     = 0.0_wp
-                      surf_usm_h%rad_sw_out(m)    = 0.0_wp
+                   DO l = 0, 1
+                      DO  m = surf_lsm_h(l)%start_index(j,i),                  &
+                              surf_lsm_h(l)%end_index(j,i)
+                         surf_lsm_h(l)%rad_sw_in(m)     = 0.0_wp
+                         surf_lsm_h(l)%rad_sw_out(m)    = 0.0_wp
+                      ENDDO
+                      DO  m = surf_usm_h(l)%start_index(j,i),                  &
+                              surf_usm_h(l)%end_index(j,i)
+                         surf_usm_h(l)%rad_sw_in(m)     = 0.0_wp
+                         surf_usm_h(l)%rad_sw_out(m)    = 0.0_wp
+                      ENDDO
                    ENDDO
 !
@@ -4949,15 +4992,17 @@
        IF (  .NOT.  radiation_interactions  ) THEN
 !--       First, for horizontal surfaces
-          DO  m = 1, surf_lsm_h%ns
-             surf_lsm_h%rad_net(m) = surf_lsm_h%rad_sw_in(m)                   &
-                                   - surf_lsm_h%rad_sw_out(m)                  &
-                                   + surf_lsm_h%rad_lw_in(m)                   &
-                                   - surf_lsm_h%rad_lw_out(m)
-          ENDDO
-          DO  m = 1, surf_usm_h%ns
-             surf_usm_h%rad_net(m) = surf_usm_h%rad_sw_in(m)                   &
-                                   - surf_usm_h%rad_sw_out(m)                  &
-                                   + surf_usm_h%rad_lw_in(m)                   &
-                                   - surf_usm_h%rad_lw_out(m)
+          DO l = 0, 1
+             DO  m = 1, surf_lsm_h(l)%ns
+                surf_lsm_h(l)%rad_net(m) = surf_lsm_h(l)%rad_sw_in(m)                &
+                                      - surf_lsm_h(l)%rad_sw_out(m)                  &
+                                      + surf_lsm_h(l)%rad_lw_in(m)                   &
+                                      - surf_lsm_h(l)%rad_lw_out(m)
+             ENDDO
+             DO  m = 1, surf_usm_h(l)%ns
+                surf_usm_h(l)%rad_net(m) = surf_usm_h(l)%rad_sw_in(m)                &
+                                      - surf_usm_h(l)%rad_sw_out(m)                  &
+                                      + surf_usm_h(l)%rad_lw_in(m)                   &
+                                      - surf_usm_h(l)%rad_lw_out(m)
+             ENDDO
           ENDDO
 !
@@ -5986,40 +6031,30 @@
 !
 !--        Horizontal walls
-!--        urban
-           DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-              surfoutll(mm) = SUM ( surf_usm_h%frac(m,:) *                  &
-                                    surf_usm_h%emissivity(m,:) )            &
-                                  * sigma_sb                                &
-                                  * surf_usm_h%pt_surface(m)**4
-              albedo_surf(mm) = SUM ( surf_usm_h%frac(m,:) *                &
-                                      surf_usm_h%albedo(m,:) )
-              emiss_surf(mm)  = SUM ( surf_usm_h%frac(m,:) *                &
-                                      surf_usm_h%emissivity(m,:) )
-              mm = mm + 1
-           ENDDO
-!
-!--        land
-           DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-              surfoutll(mm) = SUM ( surf_lsm_h%frac(m,:) *                  &
-                                    surf_lsm_h%emissivity(m,:) )            &
-                                  * sigma_sb                                &
-                                  * surf_lsm_h%pt_surface(m)**4
-              albedo_surf(mm) = SUM ( surf_lsm_h%frac(m,:) *                &
-                                      surf_lsm_h%albedo(m,:) )
-              emiss_surf(mm)  = SUM ( surf_lsm_h%frac(m,:) *                &
-                                      surf_lsm_h%emissivity(m,:) )
-              mm = mm + 1
-           ENDDO
-!
-!--        Downward facing default surfaces
-!--        TODO: Downward-facing surfaces are only available as default surfaces which lack
-!--        temperature and heat balance, therefore they have to be simulated as neutral to
-!--        radiation, that means having sw/lw reflectivity=1, so they neither absorb nor emit
-!--        radiation and they have zero net heat flux.
-           DO  m = surf_def_h(1)%start_index(j,i), surf_def_h(1)%end_index(j,i)
-              surfoutll(mm) = 0.0_wp
-              albedo_surf(mm) = 1.0_wp
-              emiss_surf(mm)  = 0.0_wp
-              mm = mm + 1
+           DO l = 0, 1
+!--           urban
+              DO  m = surf_usm_h(l)%start_index(j,i), surf_usm_h(l)%end_index(j,i)
+                 surfoutll(mm) = SUM ( surf_usm_h(l)%frac(m,:) *                  &
+                                       surf_usm_h(l)%emissivity(m,:) )            &
+                                     * sigma_sb                                   &
+                                     * surf_usm_h(l)%pt_surface(m)**4
+                 albedo_surf(mm) = SUM ( surf_usm_h(l)%frac(m,:) *                &
+                                         surf_usm_h(l)%albedo(m,:) )
+                 emiss_surf(mm)  = SUM ( surf_usm_h(l)%frac(m,:) *                &
+                                         surf_usm_h(l)%emissivity(m,:) )
+                 mm = mm + 1
+              ENDDO
+!
+!--           land
+              DO  m = surf_lsm_h(l)%start_index(j,i), surf_lsm_h(l)%end_index(j,i)
+                 surfoutll(mm) = SUM ( surf_lsm_h(l)%frac(m,:) *                  &
+                                       surf_lsm_h(l)%emissivity(m,:) )            &
+                                     * sigma_sb                                   &
+                                     * surf_lsm_h(l)%pt_surface(m)**4
+                 albedo_surf(mm) = SUM ( surf_lsm_h(l)%frac(m,:) *                &
+                                         surf_lsm_h(l)%albedo(m,:) )
+                 emiss_surf(mm)  = SUM ( surf_lsm_h(l)%frac(m,:) *                &
+                                         surf_lsm_h(l)%emissivity(m,:) )
+                 mm = mm + 1
+              ENDDO
            ENDDO
 !
@@ -6428,50 +6463,43 @@
 !
 !--        Horizontal walls
-!--        urban
-           DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-              surf_usm_h%rad_sw_in(m)  = surfinsw(mm)
-              surf_usm_h%rad_sw_out(m) = surfoutsw(mm)
-              surf_usm_h%rad_sw_dir(m) = surfinswdir(mm)
-              surf_usm_h%rad_sw_dif(m) = surfinswdif(mm)
-              surf_usm_h%rad_sw_ref(m) = surfinsw(mm) - surfinswdir(mm) -        &
-                                         surfinswdif(mm)
-              surf_usm_h%rad_sw_res(m) = surfins(mm)
-              surf_usm_h%rad_lw_in(m)  = surfinlw(mm)
-              surf_usm_h%rad_lw_out(m) = surfoutlw(mm)
-              surf_usm_h%rad_net(m)    = surfinsw(mm) - surfoutsw(mm) +          &
-                                         surfinlw(mm) - surfoutlw(mm)
-              surf_usm_h%rad_net_l(m)  = surf_usm_h%rad_net(m)
-              surf_usm_h%rad_lw_dif(m) = surfinlwdif(mm)
-              surf_usm_h%rad_lw_ref(m) = surfinlw(mm) - surfinlwdif(mm)
-              surf_usm_h%rad_lw_res(m) = surfinl(mm)
-              mm = mm + 1
-           ENDDO
-!
-!--        land
-           DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-              surf_lsm_h%rad_sw_in(m)  = surfinsw(mm)
-              surf_lsm_h%rad_sw_out(m) = surfoutsw(mm)
-              surf_lsm_h%rad_sw_dir(m) = surfinswdir(mm)
-              surf_lsm_h%rad_sw_dif(m) = surfinswdif(mm)
-              surf_lsm_h%rad_sw_ref(m) = surfinsw(mm) - surfinswdir(mm) -        &
+           DO l = 0, 1
+!--           urban
+              DO  m = surf_usm_h(l)%start_index(j,i), surf_usm_h(l)%end_index(j,i)
+                 surf_usm_h(l)%rad_sw_in(m)  = surfinsw(mm)
+                 surf_usm_h(l)%rad_sw_out(m) = surfoutsw(mm)
+                 surf_usm_h(l)%rad_sw_dir(m) = surfinswdir(mm)
+                 surf_usm_h(l)%rad_sw_dif(m) = surfinswdif(mm)
+                 surf_usm_h(l)%rad_sw_ref(m) = surfinsw(mm) - surfinswdir(mm) -        &
                                             surfinswdif(mm)
-              surf_lsm_h%rad_sw_res(m) = surfins(mm)
-              surf_lsm_h%rad_lw_in(m)  = surfinlw(mm)
-              surf_lsm_h%rad_lw_out(m) = surfoutlw(mm)
-              surf_lsm_h%rad_net(m)    = surfinsw(mm) - surfoutsw(mm) +          &
-                                         surfinlw(mm) - surfoutlw(mm)
-              surf_lsm_h%rad_lw_dif(m) = surfinlwdif(mm)
-              surf_lsm_h%rad_lw_ref(m) = surfinlw(mm) - surfinlwdif(mm)
-              surf_lsm_h%rad_lw_res(m) = surfinl(mm)
-              mm = mm + 1
-           ENDDO
-!
-!--        Downward facing default surfaces
-!--        TODO: Downward-facing surfaces are only available as default surfaces which lack
-!--        temperature and heat balance, therefore they have to be simulated as neutral to
-!--        radiation, that means having sw/lw reflectivity=1, so they neither absorb nor emit
-!--        radiation and they have zero net heat flux.
-           DO  m = surf_def_h(1)%start_index(j,i), surf_def_h(1)%end_index(j,i)
-              mm = mm + 1
+                 surf_usm_h(l)%rad_sw_res(m) = surfins(mm)
+                 surf_usm_h(l)%rad_lw_in(m)  = surfinlw(mm)
+                 surf_usm_h(l)%rad_lw_out(m) = surfoutlw(mm)
+                 surf_usm_h(l)%rad_net(m)    = surfinsw(mm) - surfoutsw(mm) +          &
+                                            surfinlw(mm) - surfoutlw(mm)
+                 surf_usm_h(l)%rad_net_l(m)  = surf_usm_h(l)%rad_net(m)
+                 surf_usm_h(l)%rad_lw_dif(m) = surfinlwdif(mm)
+                 surf_usm_h(l)%rad_lw_ref(m) = surfinlw(mm) - surfinlwdif(mm)
+                 surf_usm_h(l)%rad_lw_res(m) = surfinl(mm)
+                 mm = mm + 1
+              ENDDO
+!
+!--           land
+              DO  m = surf_lsm_h(l)%start_index(j,i), surf_lsm_h(l)%end_index(j,i)
+                 surf_lsm_h(l)%rad_sw_in(m)  = surfinsw(mm)
+                 surf_lsm_h(l)%rad_sw_out(m) = surfoutsw(mm)
+                 surf_lsm_h(l)%rad_sw_dir(m) = surfinswdir(mm)
+                 surf_lsm_h(l)%rad_sw_dif(m) = surfinswdif(mm)
+                 surf_lsm_h(l)%rad_sw_ref(m) = surfinsw(mm) - surfinswdir(mm) -        &
+                                               surfinswdif(mm)
+                 surf_lsm_h(l)%rad_sw_res(m) = surfins(mm)
+                 surf_lsm_h(l)%rad_lw_in(m)  = surfinlw(mm)
+                 surf_lsm_h(l)%rad_lw_out(m) = surfoutlw(mm)
+                 surf_lsm_h(l)%rad_net(m)    = surfinsw(mm) - surfoutsw(mm) +          &
+                                            surfinlw(mm) - surfoutlw(mm)
+                 surf_lsm_h(l)%rad_lw_dif(m) = surfinlwdif(mm)
+                 surf_lsm_h(l)%rad_lw_ref(m) = surfinlw(mm) - surfinlwdif(mm)
+                 surf_lsm_h(l)%rad_lw_res(m) = surfinl(mm)
+                 mm = mm + 1
+              ENDDO
            ENDDO
 !
@@ -6538,17 +6566,18 @@
      ENDDO
 
-     DO  m = 1, surf_usm_h%ns
-        surf_usm_h%surfhf(m) = surf_usm_h%rad_sw_in(m)  +                   &
-                               surf_usm_h%rad_lw_in(m)  -                   &
-                               surf_usm_h%rad_sw_out(m) -                   &
-                               surf_usm_h%rad_lw_out(m)
+     DO l = 0, 1
+        DO  m = 1, surf_usm_h(l)%ns
+           surf_usm_h(l)%surfhf(m) = surf_usm_h(l)%rad_sw_in(m)  +          &
+                                  surf_usm_h(l)%rad_lw_in(m)  -             &
+                                  surf_usm_h(l)%rad_sw_out(m) -             &
+                                  surf_usm_h(l)%rad_lw_out(m)
+        ENDDO
+        DO  m = 1, surf_lsm_h(l)%ns
+           surf_lsm_h(l)%surfhf(m) = surf_lsm_h(l)%rad_sw_in(m)  +          &
+                                  surf_lsm_h(l)%rad_lw_in(m)  -             &
+                                  surf_lsm_h(l)%rad_sw_out(m) -             &
+                                  surf_lsm_h(l)%rad_lw_out(m)
+        ENDDO
      ENDDO
-     DO  m = 1, surf_lsm_h%ns
-        surf_lsm_h%surfhf(m) = surf_lsm_h%rad_sw_in(m)  +                   &
-                               surf_lsm_h%rad_lw_in(m)  -                   &
-                               surf_lsm_h%rad_sw_out(m) -                   &
-                               surf_lsm_h%rad_lw_out(m)
-     ENDDO
-
      DO  l = 0, 3
 !--     urban
@@ -7020,10 +7049,12 @@
 !--    Number of horizontal surfaces including land- and roof surfaces in both USM and LSM. Note that
 !--    All horizontal surface elements are already counted in surface_mod.
-       nsurfl    = surf_usm_h%ns + surf_lsm_h%ns + surf_def_h(1)%ns
+       DO l = 0, 1
+          nsurfl = nsurfl + surf_usm_h(l)%ns + surf_lsm_h(l)%ns
+       ENDDO
 !
 !--    Number of vertical surfaces in both USM and LSM. Note that all vertical surface elements are
 !--    already counted in surface_mod.
-       DO  i = 0,3
-          nsurfl = nsurfl + surf_usm_v(i)%ns + surf_lsm_v(i)%ns
+       DO  l = 0,3
+          nsurfl = nsurfl + surf_usm_v(l)%ns + surf_lsm_v(l)%ns
        ENDDO
 
@@ -7144,82 +7175,47 @@
 !
 !--           Horizontal surfaces
-              DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
-                 k = surf_usm_h%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/iup,k,j,i/)
+              DO l = 0, 1
+                 DO  m = surf_usm_h(l)%start_index(j,i), surf_usm_h(l)%end_index(j,i)
+                    k = surf_usm_h(l)%k(m)
+                    isurf = isurf + 1
+                    surfl(:,isurf) = (/dirint_h(l),k,j,i/)
+                 ENDDO
+                 DO  m = surf_lsm_h(l)%start_index(j,i), surf_lsm_h(l)%end_index(j,i)
+                    k = surf_lsm_h(l)%k(m)
+                    isurf = isurf + 1
+                    surfl(:,isurf) = (/dirint_h(l),k,j,i/)
+                 ENDDO
               ENDDO
-
-              DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                 k = surf_lsm_h%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/iup,k,j,i/)
+!
+!--           Vertical surfaces
+              DO l = 0, 3
+                 DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
+                    k = surf_usm_v(l)%k(m)
+                    isurf = isurf + 1
+                    surfl(:,isurf) = (/dirint_v(l),k,j,i/)
+                 ENDDO
+                 DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
+                    k = surf_lsm_v(l)%k(m)
+                    isurf = isurf + 1
+                    surfl(:,isurf) = (/dirint_v(l),k,j,i/)
+                 ENDDO
               ENDDO
 
-              DO  m = surf_def_h(1)%start_index(j,i), surf_def_h(1)%end_index(j,i)
-                 k = surf_def_h(1)%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/idown,k,j,i/)
-              ENDDO
-!
-!--           Vertical surfaces
-              l = 0
-              DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
-                 k = surf_usm_v(l)%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/inorth,k,j,i/)
-              ENDDO
-              DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
-                 k = surf_lsm_v(l)%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/inorth,k,j,i/)
-              ENDDO
-
-              l = 1
-              DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
-                 k = surf_usm_v(l)%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/isouth,k,j,i/)
-              ENDDO
-              DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
-                 k = surf_lsm_v(l)%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/isouth,k,j,i/)
-              ENDDO
-
-              l = 2
-              DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
-                 k = surf_usm_v(l)%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/ieast,k,j,i/)
-              ENDDO
-              DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
-                 k = surf_lsm_v(l)%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/ieast,k,j,i/)
-              ENDDO
-
-              l = 3
-              DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
-                 k = surf_usm_v(l)%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/iwest,k,j,i/)
-              ENDDO
-              DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
-                 k = surf_lsm_v(l)%k(m)
-                 isurf = isurf + 1
-                 surfl(:,isurf) = (/iwest,k,j,i/)
-              ENDDO
            ENDDO
        ENDDO
 !
-!--    Add local MRT boxes for specified number of levels
+!--    Add local MRT boxes for the specified number of levels
+!--    !!!! NEEDS TO RETHINK AGAIN - with full 3D structure, only the one
+!--    !!!! of the upward faced horizontal surfaces should be taken (the lowest one = ground?)
+!--    !!!! mrt_nlevels number of air grid boxes might not be available
+!--    !!!! in case of overhanging structures!
        nmrtbl = 0
        IF ( mrt_nlevels > 0 )  THEN
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+                DO  m = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
 !
 !--                Skip roof if requested
-                   IF ( mrt_skip_roof  .AND.  surf_usm_h%isroof_surf(m) )  CYCLE
+                   IF ( mrt_skip_roof  .AND.  surf_usm_h(0)%isroof_surf(m) )  CYCLE
 !
 !--                Cycle over specified no of levels
@@ -7228,5 +7224,5 @@
 !
 !--             Dtto for LSM
-                DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
+                DO  m = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
                    nmrtbl = nmrtbl + mrt_nlevels
                 ENDDO
@@ -7240,11 +7236,11 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+                DO  m = surf_usm_h(0)%start_index(j,i), surf_usm_h(0)%end_index(j,i)
 !
 !--                Skip roof if requested
-                   IF ( mrt_skip_roof  .AND.  surf_usm_h%isroof_surf(m) )  CYCLE
+                   IF ( mrt_skip_roof  .AND.  surf_usm_h(0)%isroof_surf(m) )  CYCLE
 !
 !--                Cycle over specified no of levels
-                   l = surf_usm_h%k(m)
+                   l = surf_usm_h(0)%k(m)
                    DO  k = l, l + mrt_nlevels - 1
                       imrt = imrt + 1
@@ -7254,6 +7250,6 @@
 !
 !--             Dtto for LSM
-                DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
-                   l = surf_lsm_h%k(m)
+                DO  m = surf_lsm_h(0)%start_index(j,i), surf_lsm_h(0)%end_index(j,i)
+                   l = surf_lsm_h(0)%k(m)
                    DO  k = l, l + mrt_nlevels - 1
                       imrt = imrt + 1
